<template>
  <rui-field :input-id="inputId" :label="label" :help="help">
    <input v-model="date"
           v-bind="inputProps"
           :disabled="disabled"
           :required="required"
           @change="handleChange">
  </rui-field>
</template>

<script>
import { dateToInputString } from '../../../lib/Dates'
import randomString from '../../../lib/RandomString'
import RuiField from '../../Form/Field.vue'

/**
 * Wrapper for a date input, manipulating only `Date` objects.
 *
 * @bindValue 2023/09/09 00:00
 * @disableProps modelValue
 */
export default {
  name: 'RuiDateTimePicker',
  emits: [
    /**
     * Fired when date changes.
     *
     * @param {Date} details - New date
     */
    'update:modelValue',
  ],
  components: { RuiField },
  props: {
    /** Optional label for "label" HTML element */
    label: { required: false, type: String, default: null },
    /** Optional help text */
    help: { required: false, type: String, default: null },
    /** Whether to disable the input */
    disabled: { required: false, type: Boolean, default: false },
    required: { required: false, type: Boolean, default: false },

    /** Whether to display time picker */
    time: { required: false, type: Boolean, default: true },

    /** Input "id" attribute */
    inputId: { required: false, type: String, default: randomString() },
    /** Input "name" attribute */
    inputName: { required: true, type: String },
    /** Date to limit the selection */
    notBefore: { required: false, type: Date, default: null },
    /** Date to limit the selection */
    notAfter: { required: false, type: Date, default: null },
    /** Used for `v-model` or specified when input has a one-way binding */
    modelValue: { required: false, type: Date, default: null },
  },
  data () {
    return {
      date: '',
    }
  },
  computed: {
    inputProps () {
      const props = {
        type: this.$props.time ? 'datetime-local' : 'date',
        id: this.$props.inputId,
        name: this.$props.inputName,
      }
      if (this.$props.notBefore) props.min = dateToInputString(this.$props.notBefore, this.$props.time)
      if (this.$props.notAfter) props.max = dateToInputString(this.$props.notAfter, this.$props.time)

      return props
    },
  },
  methods: {
    updateState () {
      this.date = dateToInputString(this.$props.modelValue, this.$props.time)
    },
    handleChange () {
      const newDate = new Date(this.date)
      if (!(newDate instanceof Date) || isNaN(newDate.valueOf())) {
        this.$emit('update:modelValue', null)
        return
      }
      this.$emit('update:modelValue', newDate)
    },
  },
  created () {
    this.updateState()
  },
  watch: {
    modelValue (newValue, oldValue) {
      if (newValue === oldValue) return

      this.updateState()
    },
  },
}
</script>
